#include "../include/aprecv-general.h"

int print_atm_clip_packet (struct aprecv_frame_header *header, unsigned char *packet, int opt_size) {
  static struct llc_pkt_header *llc_header;
  static unsigned int oui=0;
  static unsigned short ethernet_type;

  llc_header = (struct llc_pkt_header *)(packet);
  oui = APSR_24TO32(llc_header->org_id);
  ethernet_type = apsr_ntohs(llc_header->type);
  
  if(llc_header->dsap == APSR_SAP_SNAP && llc_header->ssap == APSR_SAP_SNAP &&
     llc_header->control == APSR_CONTROL_UI && llc_header->org_id[0] == 0x00 && 
     llc_header->org_id[1] == 0x00 && llc_header->org_id[2] == 0x0) {
	  apsr_output("\n- Classical-IP over ATM(with LLC) -");
 
	  
 	  apsr_output("  DSAP: 0x%02x, SSAP: 0x%02x, Control: 0x%02x\n", 
		  llc_header->dsap, llc_header->ssap, llc_header->control);
	  apsr_output("  OUI: 0x%06x, Type: 0x%04x", oui, ethernet_type);
          if(verbose)
		  print_ethernet_proto(ethernet_type);

          if(statistic)
		  stats.c.atm_clip_llc++;

          switchto_ethernet_proto(header, packet, opt_size, ethernet_type);
  }
  else {
	  apsr_output("\n- Classical-IP over ATM(without LLC) -");
	  print_ipv4_packet(header, packet, opt_size);

	  if(statistic)
		  stats.c.atm_clip_withoutllc++;
  }	  
	  
  return(RET_SUCCESS);
}
