#include "../include/aprecv-general.h"

static const char *mplslabels[]= {	/* 0 - 16 Standard/Riverstone
					   17 - 2047 RSVP-TE
					   2048 - 4095 LDP */ 
	" (IPv4 Explicit NULL)",
	" (Router Alert Label)",
	" (IPv6 Explicit NULL)",
	" (Implicit NULL)", 
	" (Reserved)",
        " (Reserved)",
        " (Reserved)",
        " (Reserved)",
        " (Reserved)",
        " (Reserved)",
        " (Reserved)",
        " (Reserved)",
        " (Reserved)",
        " (Reserved)",
        " (Reserved)",
        " (Reserved)",
	" (End of Tunnel)",
};

int print_mpls_packet (unsigned char *packet, int opt_size) {
  static struct mpls_pkt_header *mpls_header;
  static unsigned int head;

  mpls_header = (struct mpls_pkt_header *)(packet+data_link_size+opt_size);
  head = apsr_ntohl(mpls_header->header);
  
  apsr_output("\n- MPLS Header -\n  Label: %u", 
		  APSR_MPLS_LABEL(head));
  
  if(verbose)
	  apsr_output("%s", mplslabels[APSR_MPLS_LABEL(head)]);
  
  apsr_output(", Experimental: %u", 
		  APSR_MPLS_EXP(head));
  
  apsr_output("\n  Bottom of stack: %u, TTL: %u\n", 
		  APSR_MPLS_STACK(head),
		  APSR_MPLS_TTL(head));
  
  if(statistic) 
          stats.c.mpls++;
  
  return(RET_SUCCESS);
}
