#include "../include/aprecv-general.h"

int print_slip_packet (struct aprecv_frame_header *header, unsigned char *packet, int opt_size) {
  struct slip_pkt_header *slip_packet;
  static struct ipv4_pkt_header *ip_slip_header;
   
  slip_packet=(struct slip_pkt_header *)(packet+data_link_size+opt_size);
  ip_slip_header=(struct ipv4_pkt_header *)(packet+data_link_size+opt_size+1);
  /* TODO CHECK: Is there really the first_end and last_end ? 
   *             For now i added +1 to get the right header. */
  
  if((slip_packet->first_end == 0xC0) && (slip_packet->last_end == 0xC0)) {
    apsr_output("Received SLIP Packet: \n");
    switch(APSR_IPV4_VERSION(ip_slip_header)) {
	    case 4:
  	      print_ipv4_packet(header, packet, 1);
	      break;
	    case 6:
	      print_ipv6_packet(header, packet, 1);
	      break;
	    default:
	      apsr_output("Unknown IP version: %d.\n", APSR_IPV4_VERSION(ip_slip_header));
	      break;
    }      
  }

  if(statistic) 
	  stats.c.slip++;
	  
  return(RET_SUCCESS);
}
