#include "../include/apsend-general.h"

int parseoptions (int argc, char *argv[]) {
  static struct gengetopt_args_info args_info;
  #ifdef HAVE_APSRLIB_MODULE_SUPPORT
  static struct apsr_apsend_module_info module_info;
  #endif

  if(cmd_parser (argc, argv, &args_info) != 0) {
    apsr_stream_output((FILE *) stderr, "Error: Unable to parse the command line!\n");
    exit(EXIT_FAILURE);
  }

  if(args_info.help_given) usage(argv[0], "");
  if(args_info.version_given) showversion();


  /* Load a module */
  if(args_info.module_given) {
          #ifdef HAVE_APSRLIB_MODULE_SUPPORT
	  load_module(args_info.module_arg);
	  module_name = xmalloc(strlen(args_info.module_arg)+1);
	  strncpy(module_name, args_info.module_arg, strlen(args_info.module_arg));

	  module_info = get_module_info();

	  #else
	  ERROR("Module support is not available under this operating system!");
	  ERROR("No module were loaded!\n";
	  #endif
  }

  return(RET_SUCCESS);
}

