/* Link layer sizes */
unsigned int data_link_size;

/* Logfiles, times, device and server addr */
char *device;

#define APSRSTACK_IP_1 192
#define APSRSTACK_IP_2 168
#define APSRSTACK_IP_3 0
#define APSRSTACK_IP_4 2

#define APSRSTACK_MAC_1 0x00
#define APSRSTACK_MAC_2 0x00
#define APSRSTACK_MAC_3 0xE8
#define APSRSTACK_MAC_4 0xDD
#define APSRSTACK_MAC_5 0xF2
#define APSRSTACK_MAC_6 0x31

#define APSRSTACK_TIMER_SEC 1

unsigned char apsrstack_src_mac[APSR_ETHER_ADDR_LEN];
unsigned char apsrstack_src_ip[4];

unsigned short index_number;

struct statistic {
  struct ipv4_stats {
    unsigned long processed;
    unsigned long drops;
    unsigned long fragmented;
    unsigned long checksum_errors; /* Wrong checksums */
    unsigned long dest_un_proto_un; /* ICMPv4 Destination Un. / Protocol Un. */
  } ipv4;
  struct icmpv4_stats {
    unsigned long processed;
    unsigned long drops;
    unsigned long checksum_errors; /* Wrong checksums */
  } icmpv4;
  struct ethernet_stats {
    unsigned long processed;
    unsigned long drops;
    unsigned long unknown_type; /* Unknown Ethernet type */ 
  } ethernet;
  struct arp_stats {
    unsigned long processed;
    unsigned long drops;
  } arp;
  struct tcp_stats {
    unsigned long processed;
    unsigned long drops;
    unsigned long checksum_errors; /* Wrong checksums */
  } tcp;  
  struct udp_stats {
    unsigned long processed;
    unsigned long drops;
    unsigned long checksum_errors; /* Wrong checksums */
    unsigned long dest_un_port_un; /* ICMPv4 Destination Un. / Port Un. */ 
  } udp;
} stats;

