/* Include some header files */
#include "config.h"

/* ANSI C header files */
/* stdio.h */
#ifdef HAVE_STDIO_H
 #include <stdio.h>
#endif

/* string.h */
#ifdef HAVE_STRING_H
 #include <string.h>
#endif

/* stdlib.h */
#ifdef HAVE_STDLIB_H
 #include <stdlib.h>
#endif

/* stdarg.h */
#ifdef HAVE_STDARG_H
 #include <stdarg.h>
#endif

/* unistd.h */
#ifdef HAVE_UNISTD_H
 #include <unistd.h>
#endif

/* time.h */
#ifdef HAVE_TIME_H
 #include <time.h>
#endif

/* ctype.h */
#ifdef HAVE_CTYPE_H
 #include <ctype.h>
#endif

/* fcntl.h */
#ifdef HAVE_FCNTL_H
 #include <fcntl.h>
#endif

/* signal.h */
#ifdef HAVE_SIGNAL_H
 #include <signal.h>
#endif

/* errno.h */
#ifdef HAVE_ERRNO_H
 #include <errno.h>
#endif

/* endian.h */
#ifdef HAVE_ENDIAN_H
 #include <endian.h>
#endif

/* machine/endian.h */
#ifdef HAVE_MACHINE_ENDIAN_H
 #include <machine/endian.h>
#endif

/* sys/types.h */
#ifdef HAVE_SYS_TYPES_H
 #include <sys/types.h>
#endif

/* netinet/in_systm.h */
#ifdef HAVE_NETINET_IN_SYSTM_H
 #include <netinet/in_systm.h>
#endif

/* sys/time.h */
#ifdef HAVE_SYS_TIME_H
 #include <sys/time.h>
#endif

/* sys/wait.h */
#ifdef HAVE_SYS_WAIT_H
 #include <sys/wait.h>
#endif

/* sys/socket.h */
#ifdef HAVE_SYS_SOCKET_H
 #include <sys/socket.h>
#endif

/* sys/ioctl.h */
#ifdef HAVE_SYS_IOCTL_H
 #include <sys/ioctl.h>
#endif

/* net/if.h */
#ifdef HAVE_NET_IF_H
 #include <net/if.h>
#endif

/* net/bpf.h */
#ifdef HAVE_NET_BPF_H
 #include <net/bpf.h>
/* pcap/net/bpf.h */
#elif  HAVE_PCAP_NET_BPF_H
 #include <pcap/net/bpf.h>
#endif

/* linux/sockios.h */
#ifdef HAVE_LINUX_SOCKIOS_H
 #include <linux/sockios.h>
#endif


/* We should also check if __OSTYPE_LINUX is defined. */
#if (__GLIBC__)
  /* netinet/if_ether.h */
  #ifdef HAVE_NETINET_IF_ETHER_H
   #include <netinet/if_ether.h>
  #endif

  /* net/if_arp.h */
  #ifdef HAVE_NET_IF_ARP_H
   #include <net/if_arp.h>
  #endif
#else
  /* linux/if_ether.h */
  #ifdef HAVE_LINUX_IF_ETHER_H
   #include <linux/if_ether.h>
  #endif

  /* linux/if_arp.h */
  #ifdef HAVE_LINUX_IF_ARP_H
   #include <linux/if_arp.h>
  #endif
#endif


/* netdb.h */
#ifdef HAVE_NETDB_H
 #include <netdb.h>
#endif

/* netinet/in.h */
#ifdef HAVE_NETINET_IN_H
 #include <netinet/in.h>
#endif

/* netinet/tcp.h */
#ifdef HAVE_NETINET_TCP_H
 #include <netinet/tcp.h>
#endif

/* netinet/udp.h */
#ifdef HAVE_NETINET_UDP_H
 #include <netinet/udp.h>
#endif

/* This only works with linux - this is not correct. */
/* --snip-- */
/* netinet/ip.h */
#ifdef HAVE_NETINET_IP_H
 #include <netinet/ip.h>
#endif

/* netinet/ip_icmp.h */
#ifdef HAVE_NETINET_IP_ICMP_H
 #include <netinet/ip_icmp.h>
#endif
/* --snip-- */

/* arpa/inet.h */
#ifdef HAVE_ARPA_INET_H
 #include <arpa/inet.h>
#endif

/* dlfcn.h */
#if HAVE_LIBDL && HAVE_DLFCN_H
 #include <dlfcn.h>
#endif

/* Include header file for iconv */
#ifdef HAVE_ICONV_H
 #include <iconv.h>
#endif

/* Include header file for Libz support. */
#if HAVE_LIBZ && HAVE_ZLIB_H
  /* zlib.h */
  #include <zlib.h>

  #define HAVE_APSRLIB_LIBZ_SUPPORT
#endif

/* Include header files for bluetooth support */
#if HAVE_LIBBLUETOOTH && HAVE_BLUETOOTH_BLUETOOTH_H && HAVE_BLUETOOTH_HCI_H && HAVE_BLUETOOTH_HCI_LIB_H && HAVE_BLUETOOTH_L2CAP_H
 /* bluetooth/bluetooth.h */
 #include <bluetooth/bluetooth.h>
 
 /* bluetooth/hci.h */
 #include <bluetooth/hci.h>

 /* bluetooth/hci_lib.h */
 #include <bluetooth/hci_lib.h>

 /* bluetooth/l2cap.h */
 #include <bluetooth/l2cap.h>

 #define HAVE_APSRLIB_BLUETOOTH_SUPPORT
#endif

#if HAVE_LIBDL
 #define HAVE_APSRLIB_MODULE_SUPPORT
#endif

/* netinet/ip_var.h */
#ifdef HAVE_NETINET_IP_VAR_H
 #include <netinet/ip_var.h>
#endif

