/* EGP Types */
#define APSR_EGP_TYPE_UPDATE_RES_IND	1 	/* Update Resp./Ind. */
#define APSR_EGP_TYPE_POLL_COMMAND	2	/* Poll Command */
#define APSR_EGP_TYPE_NEIGHBOR_ACQ_MES	3	/* Neighbor Acq. Mess. */
#define APSR_EGP_TYPE_NEIGHBOR_REA_MES	5	/* Neighbor Reach. Mess. */
#define APSR_EGP_TYPE_ERROR_RES_IND	8	/* Error Response/Indication */

/* EGP Codes */
#define APSR_EGP_CODE_REQUEST_COMMAND	0	/* Request Command */
#define APSR_EGP_CODE_CONFIRM_RESPONSE	1	/* Confirm Response */
#define APSR_EGP_CODE_REFUSE_RESPONSE	2	/* Refuse Response */
#define APSR_EGP_CODE_CEASE_COMMAND	3	/* Cease Command */
#define APSR_EGP_CODE_CEASE_ACK_RESP	4	/* Cease-Ack Response */
#define APSR_EGP_CODE_HELLO_COMMAND	0	/* Hello Command */
#define APSR_EGP_CODE_I_H_U_RESPONSE	1	/* I-H-U Response */

/* EGP Status */
#define APSR_EGP_STATUS_UNSPEC		0	/* Unspecified */
#define APSR_EGP_STATUS_ACTIVE_MODE	1	/* Active Mode */
#define APSR_EGP_STATUS_PASSIVE_MODE	2	/* Passive Mode */
#define APSR_EGP_STATUS_INSUF_RESOURCES 3	/* Insufficient Resources */
#define APSR_EGP_STATUS_ADMIN_PROHIB	4	/* Administratively prohib. */
#define APSR_EGP_STATUS_GOING_DOWN	5	/* Going down */
#define APSR_EGP_STATUS_PARA_PROBLEM	6	/* Parameter Problem */
#define APSR_EGP_STATUS_PROTO_VIOLATION	7	/* Protocol Violation */
#define APSR_EGP_STATUS_INTERMEDIATE	0 	/* indeterminate */
#define APSR_EGP_STATUS_UP_STATE	1	/* Up State */
#define APSR_EGP_STATUS_DOWN_STATE	2	/* Down State */
#define APSR_EGP_STATUS_UNSOL_MES_BIT	128	/* unsolicited message bit */

/* EGP Reasons */
#define APSR_EGP_REASONS_UNSPEC		0	/* Unspecified */
#define APSR_EGP_REASONS_BAD_HEADER	1	/* Bad EGP header */
#define APSR_EGP_REASONS_BAD_DATA	2	/* Bad EGP data field */
#define APSR_EGP_REASONS_REACH_INFO_UNAV 3	/* reachability info unav. */
#define APSR_EGP_REASONS_EXCESSIVE_POLL	4	/* excessive polling rate */
#define APSR_EGP_REASONS_NO_RESPONSE	5	/* no response */
