#include <apsrlib/apsrlib.h>

#define MODULE_VERSION          "0.01"
#define MODULE_NAME             "cip"
#define MODULE_DESCRIPTION      "CIP sniff module"
#define MODULE_IDENT_FAMILY     AF_INET
#define MODULE_IDENT_PN1        APSR_PROTO_UDP
#define MODULE_IDENT_PN2        APSR_PROTO_TCP
#define MODULE_IDENT_ID1        44552
#define MODULE_IDENT_ID2        44552

#define MODULE_FILTER           "(udp or tcp) and port 44552"


struct mod_cip_header {
  unsigned short int cpf;
  unsigned short int type;
  unsigned short int len_address_data;
  unsigned int identifier;
  unsigned int sequence;
  unsigned short int data_type;
  unsigned short int len;
  char *data;
};

struct apsr_aprecv_module_info module_info (void) {
  struct apsr_aprecv_module_info module_info;

  module_info.version     = MODULE_VERSION;
  module_info.name        = MODULE_NAME;
  module_info.desc        = MODULE_DESCRIPTION;
  module_info.bpf_filter  = MODULE_FILTER;
  module_info.family      = MODULE_IDENT_FAMILY;
  module_info.proto1	  = MODULE_IDENT_PN1;
  module_info.proto2      = MODULE_IDENT_PN2;
  module_info.id1         = MODULE_IDENT_ID1;
  module_info.id2         = MODULE_IDENT_ID2;
  module_info.id3         = 0;
  module_info.id4         = 0;
					
  return(module_info);
}

int module_init (unsigned char *buf, int family, unsigned short protocol_number,
                 unsigned char is_app, unsigned short id1, unsigned short id2)
{
  struct mod_cip_header *cip_header;

  if(is_app == 1) {
    if(MODULE_IDENT_FAMILY == family && (MODULE_IDENT_PN1 == protocol_number || MODULE_IDENT_PN2 == protocol_number) && (MODULE_IDENT_ID1 == id1 || MODULE_IDENT_ID2 == id2)) {

      cip_header=(struct mod_cip_header *)buf;

      printf("- CIP Header -");
      printf("  Common Packet Format: %u\n", ntohs(cip_header->cpf));
      printf("  Type ID: %u\n", ntohs(cip_header->type));
      printf("  Address Data Len: %u\n", ntohs(cip_header->len_address_data));
      printf("  Identifier: %u\n", cip_header->identifier);
      printf("  Sequence Numer: %u\n", cip_header->sequence);
      printf("  Type of Data: %u\n", ntohs(cip_header->data_type));
      printf("  Len of Data: %u\n", ntohs(cip_header->len));

      /* FIXME: This is wrong. */
      printf("  Data: %s", cip_header->data);
    }
  }

  #ifdef MODULE_DEBUG
  apsr_output("Family: %i\nPN: %i\nIA: %i\n1: %i\n2: %i\n",
		         family, protocol_number, is_app, id1, id2);
  #endif
    
  return(RET_SUCCESS);
}
