#include <apsrlib/apsrlib.h>

/* 
 * Got from 
 * http://developer.apple.com/techpubs/macos8/pdf/ASAppleTalkFiling2.1_2.2.pdf
 */

/* TODO: Flags in verbose mode */ 
/* TODO: Commands in verbose mode */

#define MODULE_VERSION		"0.01"
#define MODULE_NAME		"dsi"
#define MODULE_DESCRIPTION	"Example Data Stream Interface sniffer."
#define MODULE_IDENT_FAMILY	AF_INET
#define MODULE_IDENT_PN1	APSR_PROTO_TCP
#define MODULE_IDENT_ID1	548
#define MODULE_IDENT_ID2	548

#define MODULE_FILTER		"tcp and port 548"

struct mod_dsi_header {
	unsigned char flags;
	unsigned char command;
	unsigned short request_id;
	unsigned int error_code;
	unsigned int total_data_length;
	unsigned int reserved;
};

struct apsr_aprecv_module_info module_info (void) {
	struct apsr_aprecv_module_info module_info;

	module_info.version	= MODULE_VERSION;
	module_info.name	= MODULE_NAME;
	module_info.desc	= MODULE_DESCRIPTION;
	module_info.bpf_filter	= MODULE_FILTER; 
        module_info.family      = MODULE_IDENT_FAMILY;
        module_info.proto1      = MODULE_IDENT_PN1;
        module_info.proto2      = 0;
        module_info.id1         = MODULE_IDENT_ID1;
        module_info.id2         = MODULE_IDENT_ID2;
        module_info.id3         = 0;
        module_info.id4         = 0;
							
	return(module_info);
}

int module_init (unsigned char *buf, int family, unsigned short protocol_number,
                 unsigned short id1, unsigned short id2)
{
  struct mod_dsi_header *dsi_header;
	
  if(MODULE_IDENT_FAMILY == family && (MODULE_IDENT_ID1 == id1 || MODULE_IDENT_ID2 == id2)) {
	    dsi_header = (struct mod_dsi_header *)buf;
	    apsr_output("- DSI Header -\n");
	    apsr_output("  Flags: 0x%02x, Command: %u, Request ID: %u\n", 
			    dsi_header->flags,
			    dsi_header->command, 
			    apsr_ntohs(dsi_header->request_id));
	    apsr_output("  Error Code: %u, Total Data Length: %u, Reserved: %u\n",
			    apsr_ntohl(dsi_header->error_code),
			    apsr_ntohl(dsi_header->total_data_length),
			    apsr_ntohl(dsi_header->reserved));
  }

  #ifdef MODULE_DEBUG
  apsr_output("Family: %i\nPN: %i\n1: %i\n2: %i\n",
     family, protocol_number, id1, id2);
  #endif
  
  return(RET_SUCCESS);
}
