#include <apsrlib/apsrlib.h>

#define MODULE_VERSION		"0.01"
#define MODULE_NAME		"interbase"
#define MODULE_DESCRIPTION	"Example Interbase protocol sniffer."
#define MODULE_IDENT_FAMILY	AF_INET
#define MODULE_IDENT_PN1	APSR_PROTO_TCP
#define MODULE_IDENT_ID1	3050	
#define MODULE_IDENT_ID2	3050

#define MODULE_FILTER		"tcp and port 3050"

struct mod_interbase_header {
	unsigned int opcode;
};

struct apsr_aprecv_module_info module_info (void) {
	struct apsr_aprecv_module_info module_info;

	module_info.version	= MODULE_VERSION;
	module_info.name	= MODULE_NAME;
	module_info.desc	= MODULE_DESCRIPTION;
	module_info.bpf_filter	= MODULE_FILTER; 
        module_info.family      = MODULE_IDENT_FAMILY;
        module_info.proto1      = MODULE_IDENT_PN1;
        module_info.proto2      = 0;
        module_info.id1         = MODULE_IDENT_ID1;
        module_info.id2         = MODULE_IDENT_ID2;
        module_info.id3         = 0;
        module_info.id4         = 0;
							
	return(module_info);
}

int module_init (unsigned char *buf, int family, unsigned short protocol_number,
                 unsigned short id1, unsigned short id2)
{
  struct mod_interbase_header *interbase_header;
	
  interbase_header = (struct mod_interbase_header *)buf;
  
  if(MODULE_IDENT_ID2 == id2) {
	  apsr_output("- Interbase Request Header -\n");
  }
  else if(MODULE_IDENT_ID1 == id1) {
	  apsr_output("- Interbase Response Header -\n");
  }
  
  apsr_output("  Opcode: %u\n", apsr_ntohl(interbase_header->opcode));

  #ifdef MODULE_DEBUG
  apsr_output("Family: %i\nPN: %i\n1: %i\n2: %i\n",
     family, protocol_number, id1, id2);
  #endif
  
  return(RET_SUCCESS);
}
